<template>
  <v-row id="Home">
    <v-col sm="12" md="6">
      <v-card dark outlined color="secondary" class="d-sm-flex d-md-none mb-3">
        <v-card-text>
          Rechercher :
          <GlobalSearchBar />
        </v-card-text>
      </v-card>
      <RecipeList v-if="lastRecipes" listTitle="Dernières recettes" :recipes="lastRecipes" />
    </v-col>
    <v-col sm="12" md="6">
      <v-row>
        <v-col xs="12" md="6" class="pt-0">
          <v-card outlined class="text-center fill-height border-none">
            <v-card-text>
              Bienvenue sur Recipes, une super application de recettes de cuisine !
            </v-card-text>
          </v-card>
        </v-col>
        <v-col xs="12" md="6" class="pt-0">
          <v-card outlined class="text-center fill-height" v-if="connectedUser">
            <v-card-text>
              Bonjour {{connectedUser.Firstname + ' ' + connectedUser.Lastname}}
              <v-btn small color="secondary" :to="{name: 'user-profile', params: {userId: connectedUser.Id.toString()}}">
                Accéder à votre profil
                <v-icon right dark>mdi-account</v-icon>
              </v-btn>
            </v-card-text>
          </v-card>
        </v-col>
        <v-col>
          <v-card dark class="text-center mx-auto">
            <router-link :to="{name: 'recipe-add'}">
              <v-img src="@/assets/img/recipe-ingredients-background.png" class="white--text align-end" gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)" max-height="200px">
                <v-card-title v-text="'Créer une nouvelle recette'" class="text-decoration-none"></v-card-title>
              </v-img>
            </router-link>
          </v-card>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import RecipeService from "../services/RecipeService";
import Recipe from "../transport/Recipe";
import RecipeList from "./recipe/recipeComponents/RecipeList.vue";
import GlobalSearchBar from "./global/components/GlobalSearchBar.vue";
// @ is an alias to /src

@Component({
  components: {
    RecipeList,
    GlobalSearchBar,
  },
})
export default class Home extends Vue {
  private lastRecipes: Recipe[] = null;
  private _recipeService: RecipeService = null;

  get connectedUser() {
    return this.$store.state.connectedUser;
  }
  mounted() {
    this._recipeService = new RecipeService();
    this.fetchLastRecipes();
  }
  fetchLastRecipes() {
    this._recipeService.getLastRecipes(10).then(res => {
      this.lastRecipes = res;
    });
  }
}
</script>